diff --git a/liboctave/array/dSparse.cc b/liboctave/array/dSparse.cc
--- a/liboctave/array/dSparse.cc
+++ b/liboctave/array/dSparse.cc
@@ -7852,7 +8800,13 @@ min (const SparseMatrix& a, const Sparse
                 }
               else
                 {
-                  double tmp = octave::math::min (a.data (ja), b.data (jb));
+                  double da = a.data (ja);
+                  double db = b.data (jb);
+                  double tmp;
+                  if (includenan)
+                    tmp = da <= db ? da : (octave::math::isnan (da) ? da : db);
+                  else
+                    tmp = octave::math::min (da, db);
                   if (tmp != 0.)
                     {
                       r.data (jx) = tmp;
@@ -7884,7 +8838,7 @@ min (const SparseMatrix& a, const Sparse
 }
 
 SparseMatrix
-max (double d, const SparseMatrix& m)
+max (double d, const SparseMatrix& m, bool includenan)
 {
   SparseMatrix result;
 
@@ -7900,7 +8854,11 @@ max (double d, const SparseMatrix& m)
       for (octave_idx_type j = 0; j < nc; j++)
         for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
           {
-            double tmp = octave::math::max (d, m.data (i));
+            double tmp = m.data (i);
+            if (! includenan)
+              tmp = octave::math::max (d, tmp);
+            else if (d > tmp)
+              tmp = d;
 
             if (tmp != 0.)
               {
@@ -7912,11 +8870,21 @@ max (double d, const SparseMatrix& m)
     }
   else
     {
-      octave_idx_type nel = 0;
-      for (octave_idx_type j = 0; j < nc; j++)
-        for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
-          if (octave::math::max (d, m.data (i)) != 0.)
-            nel++;
+      if (octave::math::isnan (d) && includenan)
+        return SparseMatrix (nr, nc, d);
+
+      octave_idx_type nel;
+      if (d < 0. || octave::math::isnan (d))
+        nel = m.nnz ();
+      else
+        {
+          nel = 0;
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              if (m.data (i) > 0.
+                  || (includenan && octave::math::isnan (m.data (i))))
+                nel++;
+        }
 
       result = SparseMatrix (nr, nc, nel);
 
@@ -7926,7 +8894,11 @@ max (double d, const SparseMatrix& m)
         {
           for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
             {
-              double tmp = octave::math::max (d, m.data (i));
+              double tmp = m.data (i);
+              if (! includenan)
+                tmp = octave::math::max (d, tmp);
+              else if (d > tmp)
+                tmp = d;
               if (tmp != 0.)
                 {
                   result.xdata (ii) = tmp;
@@ -7941,13 +8913,30 @@ max (double d, const SparseMatrix& m)
 }
 
 SparseMatrix
-max (const SparseMatrix& m, double d)
-{
-  return max (d, m);
+max (const SparseMatrix& m, double d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return max (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (SparseMatrix);
+
+  SparseMatrix result (nr, nc, d);
+  for (octave_idx_type j = 0; j < nc; j++)
+    for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+      if (octave::math::isnan (m.data (i)))
+        result.xdata (m.ridx (i) + j * nr) = m.data (i);
+
+  return result;
 }
 
 SparseMatrix
-max (const SparseMatrix& a, const SparseMatrix& b)
+max (const SparseMatrix& a, const SparseMatrix& b, bool includenan)
 {
   SparseMatrix r;
 
@@ -7977,7 +8966,11 @@ max (const SparseMatrix& a, const Sparse
               octave_quit ();
               if ((! jb_lt_max) || (ja_lt_max && (a.ridx (ja) < b.ridx (jb))))
                 {
-                  double tmp = octave::math::max (a.data (ja), 0.);
+                  double tmp = a.data (ja);
+                  if (! includenan)
+                    tmp = octave::math::max (tmp, 0.);
+                  else if (0. > tmp)
+                    tmp = 0.;
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = a.ridx (ja);
@@ -7990,7 +8983,11 @@ max (const SparseMatrix& a, const Sparse
               else if ((! ja_lt_max)
                        || (jb_lt_max && (b.ridx (jb) < a.ridx (ja))))
                 {
-                  double tmp = octave::math::max (0., b.data (jb));
+                  double tmp = b.data (jb);
+                  if (! includenan)
+                    tmp = octave::math::max (0., tmp);
+                  else if (0. > tmp)
+                    tmp = 0.;
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = b.ridx (jb);
@@ -8002,7 +8999,13 @@ max (const SparseMatrix& a, const Sparse
                 }
               else
                 {
-                  double tmp = octave::math::max (a.data (ja), b.data (jb));
+                  double da = a.data (ja);
+                  double db = b.data (jb);
+                  double tmp;
+                  if (includenan)
+                    tmp = da >= db ? da : (octave::math::isnan (da) ? da : db);
+                  else
+                    tmp = octave::math::max (da, db);
                   if (tmp != 0.)
                     {
                       r.data (jx) = tmp;
diff --git a/liboctave/array/dSparse.h b/liboctave/array/dSparse.h
--- a/liboctave/array/dSparse.h
+++ b/liboctave/array/dSparse.h
@@ -105,10 +105,19 @@ public:
 
   bool is_symmetric (void) const;
 
-  SparseMatrix max (int dim = -1) const;
-  SparseMatrix max (Array<octave_idx_type>& index, int dim = -1) const;
-  SparseMatrix min (int dim = -1) const;
-  SparseMatrix min (Array<octave_idx_type>& index, int dim = -1) const;
+  SparseMatrix max (int dim = -1, bool includenan = false) const;
+  SparseMatrix max (Array<octave_idx_type>& index,
+                    int dim = -1, bool includenan = false) const;
+  SparseMatrix min (int dim = -1, bool includenan = false) const;
+  SparseMatrix min (Array<octave_idx_type>& index,
+                    int dim = -1, bool includenan = false) const;
+
+  SparseMatrix cummax (int dim = -1, bool includenan = false) const;
+  SparseMatrix cummax (Array<octave_idx_type>& index,
+                       int dim = -1, bool includenan = false) const;
+  SparseMatrix cummin (int dim = -1, bool includenan = false) const;
+  SparseMatrix cummin (Array<octave_idx_type>& index,
+                       int dim = -1, bool includenan = false) const;
 
   // destructive insert/delete/reorder operations
 
@@ -488,15 +497,21 @@ extern OCTAVE_API SparseMatrix operator 
 extern OCTAVE_API SparseMatrix operator * (const SparseMatrix&,
                                            const PermMatrix&);
 
-extern OCTAVE_API SparseMatrix min (double d, const SparseMatrix& m);
-extern OCTAVE_API SparseMatrix min (const SparseMatrix& m, double d);
+extern OCTAVE_API SparseMatrix min (double d, const SparseMatrix& m,
+                                    bool includenan = false);
+extern OCTAVE_API SparseMatrix min (const SparseMatrix& m, double d,
+                                    bool includenan = false);
 extern OCTAVE_API SparseMatrix min (const SparseMatrix& a,
-                                    const SparseMatrix& b);
+                                    const SparseMatrix& b,
+                                    bool includenan = false);
 
-extern OCTAVE_API SparseMatrix max (double d, const SparseMatrix& m);
-extern OCTAVE_API SparseMatrix max (const SparseMatrix& m, double d);
+extern OCTAVE_API SparseMatrix max (double d, const SparseMatrix& m,
+                                    bool includenan = false);
+extern OCTAVE_API SparseMatrix max (const SparseMatrix& m, double d,
+                                    bool includenan = false);
 extern OCTAVE_API SparseMatrix max (const SparseMatrix& a,
-                                    const SparseMatrix& b);
+                                    const SparseMatrix& b,
+                                    bool includenan = false);
 
 SPARSE_SMS_CMP_OP_DECLS (SparseMatrix, double, OCTAVE_API)
 SPARSE_SMS_BOOL_OP_DECLS (SparseMatrix, double, OCTAVE_API)
diff --git a/liboctave/array/fCMatrix.cc b/liboctave/array/fCMatrix.cc
--- a/liboctave/array/fCMatrix.cc
+++ b/liboctave/array/fCMatrix.cc
@@ -3641,33 +3641,68 @@ operator * (const FloatComplexMatrix& a,
     return T (nr, nc);
 
 FloatComplexMatrix
-min (const FloatComplex& c, const FloatComplexMatrix& m)
+min (const FloatComplex& c, const FloatComplexMatrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (FloatComplexMatrix);
 
+  if (octave::math::isnan (c) && includenan)
+    return FloatComplexMatrix (nr, nc, c);
+
+  FloatComplexMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = c <= m(i, j) ? c : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (c, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+FloatComplexMatrix
+min (const FloatComplexMatrix& m, const FloatComplex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return min (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (FloatComplexMatrix);
+
   FloatComplexMatrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (c, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : c;
       }
 
   return result;
 }
 
 FloatComplexMatrix
-min (const FloatComplexMatrix& m, const FloatComplex& c)
-{
-  return min (c, m);
-}
-
-FloatComplexMatrix
-min (const FloatComplexMatrix& a, const FloatComplexMatrix& b)
+min (const FloatComplexMatrix& a, const FloatComplexMatrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
@@ -3680,66 +3715,93 @@ min (const FloatComplexMatrix& a, const 
 
   FloatComplexMatrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
+  if (includenan)
     {
-      bool columns_are_real_only = true;
-      for (octave_idx_type i = 0; i < nr; i++)
-        {
-          octave_quit ();
-          if (octave::math::imag (a(i, j)) != 0.0 || octave::math::imag (b(i, j)) != 0.0)
-            {
-              columns_are_real_only = false;
-              break;
-            }
-        }
-
-      if (columns_are_real_only)
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            result(i, j) = octave::math::min (octave::math::real (a(i, j)),
-                                              octave::math::real (b(i, j)));
-        }
-      else
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::min (a(i, j), b(i, j));
-            }
-        }
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) <= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (a(i, j), b(i, j));
+          }
     }
 
   return result;
 }
 
 FloatComplexMatrix
-max (const FloatComplex& c, const FloatComplexMatrix& m)
+max (const FloatComplex& c, const FloatComplexMatrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (FloatComplexMatrix);
 
+  if (octave::math::isnan (c) && includenan)
+    return FloatComplexMatrix (nr, nc, c);
+
+  FloatComplexMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = c >= m(i, j) ? c : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (c, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+FloatComplexMatrix
+max (const FloatComplexMatrix& m, const FloatComplex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return max (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (FloatComplexMatrix);
+
   FloatComplexMatrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::max (c, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : c;
       }
 
   return result;
 }
 
 FloatComplexMatrix
-max (const FloatComplexMatrix& m, const FloatComplex& c)
-{
-  return max (c, m);
-}
-
-FloatComplexMatrix
-max (const FloatComplexMatrix& a, const FloatComplexMatrix& b)
+max (const FloatComplexMatrix& a, const FloatComplexMatrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
@@ -3752,36 +3814,25 @@ max (const FloatComplexMatrix& a, const 
 
   FloatComplexMatrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
+  if (includenan)
     {
-      bool columns_are_real_only = true;
-      for (octave_idx_type i = 0; i < nr; i++)
-        {
-          octave_quit ();
-          if (octave::math::imag (a(i, j)) != 0.0 || octave::math::imag (b(i, j)) != 0.0)
-            {
-              columns_are_real_only = false;
-              break;
-            }
-        }
-
-      if (columns_are_real_only)
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::max (octave::math::real (a(i, j)),
-                                                octave::math::real (b(i, j)));
-            }
-        }
-      else
-        {
-          for (octave_idx_type i = 0; i < nr; i++)
-            {
-              octave_quit ();
-              result(i, j) = octave::math::max (a(i, j), b(i, j));
-            }
-        }
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) >= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (a(i, j), b(i, j));
+          }
     }
 
   return result;
diff --git a/liboctave/array/fCMatrix.h b/liboctave/array/fCMatrix.h
--- a/liboctave/array/fCMatrix.h
+++ b/liboctave/array/fCMatrix.h
@@ -467,18 +467,24 @@ extern OCTAVE_API FloatComplexMatrix ope
                                                  const FloatComplexMatrix&);
 
 extern OCTAVE_API FloatComplexMatrix min (const FloatComplex& c,
-                                          const FloatComplexMatrix& m);
+                                          const FloatComplexMatrix& m,
+                                          bool includenan = false);
 extern OCTAVE_API FloatComplexMatrix min (const FloatComplexMatrix& m,
-                                          const FloatComplex& c);
+                                          const FloatComplex& c,
+                                          bool includenan = false);
 extern OCTAVE_API FloatComplexMatrix min (const FloatComplexMatrix& a,
-                                          const FloatComplexMatrix& b);
+                                          const FloatComplexMatrix& b,
+                                          bool includenan = false);
 
 extern OCTAVE_API FloatComplexMatrix max (const FloatComplex& c,
-                                          const FloatComplexMatrix& m);
+                                          const FloatComplexMatrix& m,
+                                          bool includenan = false);
 extern OCTAVE_API FloatComplexMatrix max (const FloatComplexMatrix& m,
-                                          const FloatComplex& c);
+                                          const FloatComplex& c,
+                                          bool includenan = false);
 extern OCTAVE_API FloatComplexMatrix max (const FloatComplexMatrix& a,
-                                          const FloatComplexMatrix& b);
+                                          const FloatComplexMatrix& b,
+                                          bool includenan = false);
 
 extern OCTAVE_API FloatComplexMatrix
 linspace (const FloatComplexColumnVector& x1,
diff --git a/liboctave/array/fCNDArray.cc b/liboctave/array/fCNDArray.cc
--- a/liboctave/array/fCNDArray.cc
+++ b/liboctave/array/fCNDArray.cc
@@ -668,53 +668,61 @@ static const FloatComplex FloatComplex_N
                                                    octave::numeric_limits<float>::NaN ());
 
 FloatComplexNDArray
-FloatComplexNDArray::max (int dim) const
+FloatComplexNDArray::max (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<FloatComplex> (*this, dim, mx_inline_max);
+  return do_mx_minmax_op<FloatComplex> (*this, dim, mx_inline_max, includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::max (Array<octave_idx_type>& idx_arg, int dim) const
+FloatComplexNDArray::max (Array<octave_idx_type>& idx_arg,
+                          int dim, bool includenan) const
 {
-  return do_mx_minmax_op<FloatComplex> (*this, idx_arg, dim, mx_inline_max);
+  return do_mx_minmax_op<FloatComplex> (*this, idx_arg, dim, mx_inline_max,
+                                        includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::min (int dim) const
+FloatComplexNDArray::min (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<FloatComplex> (*this, dim, mx_inline_min);
+  return do_mx_minmax_op<FloatComplex> (*this, dim, mx_inline_min, includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::min (Array<octave_idx_type>& idx_arg, int dim) const
+FloatComplexNDArray::min (Array<octave_idx_type>& idx_arg,
+                          int dim, bool includenan) const
 {
-  return do_mx_minmax_op<FloatComplex> (*this, idx_arg, dim, mx_inline_min);
+  return do_mx_minmax_op<FloatComplex> (*this, idx_arg, dim, mx_inline_min,
+                                        includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::cummax (int dim) const
+FloatComplexNDArray::cummax (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<FloatComplex> (*this, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<FloatComplex> (*this, dim, mx_inline_cummax,
+                                           includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::cummax (Array<octave_idx_type>& idx_arg, int dim) const
+FloatComplexNDArray::cummax (Array<octave_idx_type>& idx_arg,
+                             int dim, bool includenan) const
 {
   return do_mx_cumminmax_op<FloatComplex> (*this, idx_arg, dim,
-                                           mx_inline_cummax);
+                                           mx_inline_cummax, includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::cummin (int dim) const
+FloatComplexNDArray::cummin (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<FloatComplex> (*this, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<FloatComplex> (*this, dim, mx_inline_cummin,
+                                           includenan);
 }
 
 FloatComplexNDArray
-FloatComplexNDArray::cummin (Array<octave_idx_type>& idx_arg, int dim) const
+FloatComplexNDArray::cummin (Array<octave_idx_type>& idx_arg,
+                             int dim, bool includenan) const
 {
   return do_mx_cumminmax_op<FloatComplex> (*this, idx_arg, dim,
-                                           mx_inline_cummin);
+                                           mx_inline_cummin, includenan);
 }
 
 FloatNDArray
diff --git a/liboctave/array/fCNDArray.h b/liboctave/array/fCNDArray.h
--- a/liboctave/array/fCNDArray.h
+++ b/liboctave/array/fCNDArray.h
@@ -88,17 +88,19 @@ public:
   FloatComplexNDArray concat (const FloatNDArray& rb,
                               const Array<octave_idx_type>& ra_idx);
 
-  FloatComplexNDArray max (int dim = -1) const;
-  FloatComplexNDArray max (Array<octave_idx_type>& index, int dim = -1) const;
-  FloatComplexNDArray min (int dim = -1) const;
-  FloatComplexNDArray min (Array<octave_idx_type>& index, int dim = -1) const;
+  FloatComplexNDArray max (int dim = -1, bool includenan = false) const;
+  FloatComplexNDArray max (Array<octave_idx_type>& index,
+                           int dim = -1, bool includenan = false) const;
+  FloatComplexNDArray min (int dim = -1, bool includenan = false) const;
+  FloatComplexNDArray min (Array<octave_idx_type>& index,
+                           int dim = -1, bool includenan = false) const;
 
-  FloatComplexNDArray cummax (int dim = -1) const;
+  FloatComplexNDArray cummax (int dim = -1, bool includenan = false) const;
   FloatComplexNDArray cummax (Array<octave_idx_type>& index,
-                              int dim = -1) const;
-  FloatComplexNDArray cummin (int dim = -1) const;
+                              int dim = -1, bool includenan = false) const;
+  FloatComplexNDArray cummin (int dim = -1, bool includenan = false) const;
   FloatComplexNDArray cummin (Array<octave_idx_type>& index,
-                              int dim = -1) const;
+                              int dim = -1, bool includenan = false) const;
 
   FloatComplexNDArray diff (octave_idx_type order = 1, int dim = -1) const;
 
diff --git a/liboctave/array/fMatrix.cc b/liboctave/array/fMatrix.cc
--- a/liboctave/array/fMatrix.cc
+++ b/liboctave/array/fMatrix.cc
@@ -3030,28 +3030,148 @@ operator * (const FloatMatrix& a, const 
     return T (nr, nc);
 
 FloatMatrix
-min (float d, const FloatMatrix& m)
+min (float d, const FloatMatrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (FloatMatrix);
 
+  if (octave::math::isnan (d) && includenan)
+    return FloatMatrix (nr, nc, d);
+
+  FloatMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = d <= m(i, j) ? d : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (d, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+FloatMatrix
+min (const FloatMatrix& m, float d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return min (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (FloatMatrix);
+
   FloatMatrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (d, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : d;
       }
 
   return result;
 }
 
 FloatMatrix
-min (const FloatMatrix& m, float d)
+min (const FloatMatrix& a, const FloatMatrix& b, bool includenan)
 {
+  octave_idx_type nr = a.rows ();
+  octave_idx_type nc = a.columns ();
+
+  if (nr != b.rows () || nc != b.columns ())
+    (*current_liboctave_error_handler)
+      ("two-arg min requires same size arguments");
+
+  EMPTY_RETURN_CHECK (FloatMatrix);
+
+  FloatMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) <= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (a(i, j), b(i, j));
+          }
+    }
+
+  return result;
+}
+
+FloatMatrix
+max (float d, const FloatMatrix& m, bool includenan)
+{
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (FloatMatrix);
+
+  if (octave::math::isnan (d) && includenan)
+    return FloatMatrix (nr, nc, d);
+
+  FloatMatrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = d >= m(i, j) ? d : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (d, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+FloatMatrix
+max (const FloatMatrix& m, float d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return max (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
@@ -3063,96 +3183,46 @@ min (const FloatMatrix& m, float d)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (m(i, j), d);
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : d;
       }
 
   return result;
 }
 
 FloatMatrix
-min (const FloatMatrix& a, const FloatMatrix& b)
+max (const FloatMatrix& a, const FloatMatrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
 
   if (nr != b.rows () || nc != b.columns ())
     (*current_liboctave_error_handler)
-      ("two-arg min requires same size arguments");
+      ("two-arg max requires same size arguments");
 
   EMPTY_RETURN_CHECK (FloatMatrix);
 
   FloatMatrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::min (a(i, j), b(i, j));
-      }
-
-  return result;
-}
-
-FloatMatrix
-max (float d, const FloatMatrix& m)
-{
-  octave_idx_type nr = m.rows ();
-  octave_idx_type nc = m.columns ();
-
-  EMPTY_RETURN_CHECK (FloatMatrix);
-
-  FloatMatrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (d, m(i, j));
-      }
-
-  return result;
-}
-
-FloatMatrix
-max (const FloatMatrix& m, float d)
-{
-  octave_idx_type nr = m.rows ();
-  octave_idx_type nc = m.columns ();
-
-  EMPTY_RETURN_CHECK (FloatMatrix);
-
-  FloatMatrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (m(i, j), d);
-      }
-
-  return result;
-}
-
-FloatMatrix
-max (const FloatMatrix& a, const FloatMatrix& b)
-{
-  octave_idx_type nr = a.rows ();
-  octave_idx_type nc = a.columns ();
-
-  if (nr != b.rows () || nc != b.columns ())
-    (*current_liboctave_error_handler)
-      ("two-arg max requires same size arguments");
-
-  EMPTY_RETURN_CHECK (FloatMatrix);
-
-  FloatMatrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (a(i, j), b(i, j));
-      }
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) >= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (a(i, j), b(i, j));
+          }
+    }
 
   return result;
 }
diff --git a/liboctave/array/fMatrix.h b/liboctave/array/fMatrix.h
--- a/liboctave/array/fMatrix.h
+++ b/liboctave/array/fMatrix.h
@@ -391,13 +391,19 @@ extern OCTAVE_API FloatMatrix xgemm (con
 extern OCTAVE_API FloatMatrix operator * (const FloatMatrix& a,
                                           const FloatMatrix& b);
 
-extern OCTAVE_API FloatMatrix min (float d, const FloatMatrix& m);
-extern OCTAVE_API FloatMatrix min (const FloatMatrix& m, float d);
-extern OCTAVE_API FloatMatrix min (const FloatMatrix& a, const FloatMatrix& b);
+extern OCTAVE_API FloatMatrix min (float d, const FloatMatrix& m,
+                                   bool includenan = false);
+extern OCTAVE_API FloatMatrix min (const FloatMatrix& m, float d,
+                                   bool includenan = false);
+extern OCTAVE_API FloatMatrix min (const FloatMatrix& a, const FloatMatrix& b,
+                                   bool includenan = false);
 
-extern OCTAVE_API FloatMatrix max (float d, const FloatMatrix& m);
-extern OCTAVE_API FloatMatrix max (const FloatMatrix& m, float d);
-extern OCTAVE_API FloatMatrix max (const FloatMatrix& a, const FloatMatrix& b);
+extern OCTAVE_API FloatMatrix max (float d, const FloatMatrix& m,
+                                   bool includenan = false);
+extern OCTAVE_API FloatMatrix max (const FloatMatrix& m, float d,
+                                   bool includenan = false);
+extern OCTAVE_API FloatMatrix max (const FloatMatrix& a, const FloatMatrix& b,
+                                   bool includenan = false);
 
 extern OCTAVE_API FloatMatrix linspace (const FloatColumnVector& x1,
                                         const FloatColumnVector& x2,
